/******************************************************************
 *	traVA for `sQRPR
 ******************************************************************
 *	
 *	
 *	R}hs:
static	void cmdTxRx(RxBuf *q);
static	void cmdPeek(RxBuf *q);
static	void cmdPoke(RxBuf *q);
 *
 *	trax_[NGXg̏:
uchar	usbFunctionSetup(uchar data[8]);
 *
 *	ƃC:
static	void hardwareInit(void);
int		main(void);
 *
 */


/******************************************************************
 *	include
 ******************************************************************
 */

#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>

#include "usbdrv/usbdrv.h"
#include "usbdrv/oddebug.h"

#define	MAX_RXPACKET	24

#include "usart.h"


/******************************************************************
 *	Device / Config Descriptor
 ******************************************************************
 */
uchar usbFunctionDescriptor(usbRequest_t *rq);
#include "usbdesc.h"

//
//	Rg[]Ŏ󂯎R}hpPbg.
//
typedef	struct {
	uchar bmRequestType;
	uchar cmd;
	uchar *adr;
	uchar data0;
	uchar data1;
	int   wLength;
} RxBuf;

//
//	cmd = [ 0 aa ccccc ]   a = area , c = cmd
//
enum {
	CMD_NOP  ,
	CMD_01	 ,
	CMD_02	 ,
	CMD_03	 ,
	CMD_04	 ,
	CMD_PEEK ,
	CMD_POKE ,
	CMD_BAUD ,
	CMD_MASK = 0x1f,
};


//
//	[ǂݏ̃IvV.
//
enum {
	AREA_RAM    = 0   ,
	AREA_EEPROM = 0x20,
	AREA_PGMEM  = 0x40,
	AREA_MASK	= 0x60,
};


static uchar result[MAX_RXPACKET];	//Rg[]R}h̏ʃobt@(hostԑp)

void pgmemcpy(uchar *t,int adr,uchar size);

/******************************************************************
 *	qrQRQbf[^̎.
 ******************************************************************
    0      1      2      3      4      5      6      7
 +------+------+---------------------------+-------------+
 | req  | cmd  | Mf[^iőSoCgj|   wlength   |
 +------+------+---------------------------+-------------+
Mf[^͓sEl߂ĂB
cmd ͗LȑM
0   ̂Ƃ͑Mf[^Ȃ

 * MpPbg
    0      1      2      3      4      5      6      7
 +------+------------------------------------------------+
 | size |     Mf[^iőVoCgj                 |
 +------+------------------------------------------------+
size͂O`V
sizêlraPɂȂƂ͑MۂꂽB(TxBuf FULL)
̏ꍇob͓f[^đB
 */
static int cmdTxRx(RxBuf *q)
{
	uchar *p  = (uchar *)q;	//GCAXptr.
	uchar cnt = q->cmd;		//.
	uchar txack;

	if(	rsptr < TXBUF_SIZE) {	//Mobt@Ƀf[^cĂȂ,
		//󂯎f[^j.
		//đv.
		txack = 0x80;
	}else{
		//
		//Mobt@Ƀf[^Zbg.
		//
		memcpy(rsbuf , p+2 ,4);	//ӁFLӂȃf[^͌l߂Ă邱.
		rsptr = (4-cnt);		//obt@ǂݏo|C^͗Lӂȃf[^̐擪w.
		txack = 0;
	}
	//
	//Mobt@ԋp.
	//
	return USART_RecvData(result,txack);
}

/******************************************************************
 *	[ǂݏo.
 ******************************************************************
    0      1      2      3      4      5      6      7
 +------+------+-------------+------+------+-------------+
 | req  | cmd  |     adr     | len  |      |   wlength   |
 +------+------+-------------+------+------+-------------+
len͂O`W
UgpPbgiWoCgjŃf[^Ԃ.
 */
static void cmdPeek(RxBuf *q)
{
	uchar sub = q->cmd & AREA_MASK;
	if(sub == AREA_RAM) {
		memcpy(result,q->adr,q->data0);
	}else
	if(sub == AREA_PGMEM) {
		pgmemcpy(result,(int)q->adr,q->data0);
	}
}

/******************************************************************
 *	[.
 ******************************************************************
    0      1      2      3      4      5      6      7
 +------+------+-------------+------+------+-------------+
 | req  | cmd  |     adr     |data0 |data1 |   wlength   |
 +------+------+-------------+------+------+-------------+
data1[̂Ƃ́A}XNp^[Iȏŏ.

UgpPbg͕svA_~[łWoCgԂ.
 */
static void cmdPoke(RxBuf *q)
{
	uchar *p = (uchar *)q->adr;
	if(q->data1) {	//}XNt̏.
		*p = (*p & q->data1) | q->data0;
	}else{			//ׂ.
		*p = q->data0;
	}
}

/******************************************************************
 *	ftHgȊÕRg[]ɌĂяoGg[.
 ******************************************************************
 *	x_NGXg̓NXNGXgɉ.
 *	   :usbRequset_t *rq;      NGXgpPbg\.
 *          ڍׂ usbdrv.h Q.
 *			rq->bRequest ɃR}hԍ邱Ƃ.
 *	߂l :uchar         replyLen 
 *			oCgԂꍇ usbMsgPtrɃAhXĂ.
 *			0xff Ԃꍇ usbFunctionRead()Ăяo.
 *
 */
uchar usbFunctionSetup(uchar data[8])
{
    usbMsgPtr = result;

	RxBuf *q = (RxBuf *)data;
	uchar cmd = q->cmd & CMD_MASK;	//R}h.

	if(cmd <= CMD_04) {
		return cmdTxRx(q);			// qrQRQbf[^̑pPbg.
	}
	if(cmd == CMD_PEEK) {
		cmdPeek(q);			// [ǂݏo.
		return 8;
	}
	if(cmd == CMD_POKE) {
		cmdPoke(q);			// [.
		return 8;
	}
	if(cmd == CMD_BAUD) {
		cmdBaud(data[2],data[3],data[4]);	// {[[gݒ.
		return 8;
	}
	return 8;
}

/******************************************************************
 *	|[g̏
 ******************************************************************
 */
static void hardwareInit(void)
{
#if STARTUP_DELAY
	uchar wait;
	/* Power ON delay (300ms) */
	for (wait=0; wait<150; wait++) {
		delay_10us(200);		// 2ms
	}
#endif

	// PORTBׂē̓[hɂPull-UP.
	DDRB  = 0;
	PORTB = 0xff;

	/* PD5 USB D-, PD2modeWpp pullup */
	PORTD |= ((1<<PD6)|(1<<PD5)|(1<<PD2)|(1<<PD1)|(1<<PD0));

	/* all outputs except (USB data, PD2, PD1, PD0) */
	DDRD = ~(USBMASK | (1<<PD6)| (1<<PD2)|(1<<PD1)|(1<<PD0));
}


/*
         ATtiny2313
         ___    ___
RESET    [1  |__| 20] Vcc
PD0(NC)  [2       19] PB7(SCK)
PD1(NC)  [3       18] PB6(MISO)
XTAL2    [4       17] PB5(MOSI)
XTAL1    [5       16] PB4(RST)
PD2      [6       15] PB3(BUSY LED)
PD3      [7       14] PB2(READY LED)
PD4      [8       13] PB1(NC)
PD5(PUP) [9       12] PB0(NC)
GND      [10      11] PD6(NC)
         ~~~~~~~~~~~

   ---------------------------------------
   SPI:     PB7-4 ===> [Target AVR Device](MISOMOSI͌)
   USB:     PD4   ===> USB D-
            PD3   ===> USB D+
            PD5   ===> USB D- PULL UP
   XTAL:    XTAL1,2 => Crystal 12MHz
   PD2:     Clock Output(12MHz) Optional
   ---------------------------------------

 FUSEݒ
q[Y̐ݒ́COt 12MHz ̃NX^ɍ킹Aȉ̂悤ɐݒ肵܂B

Low: 11111111 (0xFF)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PD2ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11011 (0xDB)
     |||||||+-- RSTDISBL (RESETs 1:L, 0:(PA2))
     ||||+++-- BODLEVEL[2:0] (111:Off, 110:1.8, 101:2.7, 100:4.3)
     |||+-- WDTON (WDT 0:펞ON, 1:ʏ)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
     |+-- EESAVE (EEPROM 1:, 0:ێ)
     +-- DWEN (On-ChipfobO 1:, 0:L)

Ext: -------1 (0xFF)
            +-- SPMEN (SPM 1:, 0:L)


*/

/******************************************************************
 *	C
 ******************************************************************
 */
int main(void)
{
	hardwareInit();
	USART_Init(USART_default_baud);
	usbInit();

	sei();
	for(;;){
		usbPoll();
		USART_RecvTask();
		USART_SendTask();
	}
}

